#include <stdio.h>

int ip = 0, dp = 0;
const int memsize = 32768;
char instr [80];
char mem [memsize] = {0};

int check_brackets (char* ins)
{
 int counter = 0;
 for (; *ins != '\0'; ins++)
 {switch (*ins)
  {
   case '[': counter++; break;
   case ']': counter--; break;
  }} 
 return counter;
}

int match_bracket (int src)
{
 int counter = 1;
 if (instr [src] == '[')
  do
  {
   src++;
   if (instr [src] == '[') counter++; else if (instr [src] == ']') counter--;
  } while (counter || (instr [src] != ']'));
 else if (instr [src] == ']')
  do
  {
   src--;
   if (instr [src] == ']') counter++; else if (instr [src] == '[') counter--;
  } while (counter || (instr [src] != '['));
 else return -1;
 return src;
}

void writeln (char dst [], char* src)
{
 int pos = 0;
 while (*src != '\0') dst [pos++] = *src++;
 dst [pos] = '\0';
}

int main ()
{
 printf ("Welcome to the Brainf*ck interpreter. Do you wish to use the library or enter your own program? (l/o): ");
 char ownlib;
 scanf ("%c\13\10", &ownlib);
 if (ownlib == 'o') {printf ("Enter your program: "); scanf ("%s ", instr);}
  else if (ownlib == 'l') {writeln (instr, ",>,[-<+>]<.");}
   else {printf ("Incorrect choice, terminating..."); return 0;}
 if (check_brackets (instr)) return 1;
 for (; instr [ip] != '\0';)
 {
  switch (instr [ip])
  {
   case '<': if (dp == 0) dp = memsize - 1; else dp--; ip++; break;
   case '>': if (dp == memsize - 1) dp = 0; else dp++; ip++; break;
   case '+': mem [dp]++; ip++; break;
   case '-': mem [dp]--; ip++; break;
   case '.': printf ("%c", mem [dp]); ip++; break;
   case ',': scanf ("%c", &mem [dp]); ip++; break;
   case '[': if (mem [dp] == 0) ip = (match_bracket (ip)) + 1; else ip++; break;
   case ']': ip = match_bracket (ip); break;
   default: ip++; break;
  }
 }
 return 0;
}
